﻿@namespace ServiceDesk.Presentation.Components.Mantenimientos

@using System.Collections.ObjectModel
@using System.Collections;
@using Microsoft.AspNetCore.Components.Authorization

@inject DepartamentoAgent departamentoAgent

<TelerikGrid Data=@GridData EditMode="@GridEditMode.Popup"
             Pageable="true" PageSize=25
             OnUpdate=@UpdateItem OnDelete=@DeleteItem OnCreate=@CreateItem>
    <GridToolBar>
        <GridCommandButton Command="Add" Icon="add">Agregar Departamento</GridCommandButton>
    </GridToolBar>
    <GridColumns>
        <GridColumn Field=@nameof(DepartamentoDto.Nombre) Editable="true" />
        <GridColumn Field=@nameof(DepartamentoDto.CreadoPor) Editable="false" Title="Creado Por" />
        <GridColumn Field=@nameof(DepartamentoDto.FechaRegistro) Editable="false" DisplayFormat="{0:dd/MM/yyyy hh:mm tt}" Title="Fecha de Registro" />
        <GridColumn Field=@nameof(DepartamentoDto.ModificadoPor) Editable="false" Title="Modificado Por" />
        <GridColumn Field=@nameof(DepartamentoDto.FechaModificacion) Editable="false" DisplayFormat="{0:dd/MM/yyyy hh:mm tt}" Title="Fecha de Modificación" />
        <GridCommandColumn Width="120px">
            <GridCommandButton Command="Edit" Icon="edit"></GridCommandButton>
            <GridCommandButton Command="Delete" Icon="delete"></GridCommandButton>
        </GridCommandColumn>
    </GridColumns>
</TelerikGrid>

@code {
    [CascadingParameter]
    private Task<AuthenticationState> authenticationState { get; set; }

    [CascadingParameter]
    private DialogFactory Dialog { get; set; }

    public List<DepartamentoDto> GridData { get; set; } = new List<DepartamentoDto>();

    protected override async Task OnInitializedAsync()
    {
        try
        {
            Timer timer = new Timer();
            timer.Interval = 5000;
            timer.Elapsed += timer_elapsed;
            await LoadData();
        }
        catch (Exception ex)
        {
            Console.WriteLine(ex.Message);
            throw;
        }

    }

    private async void timer_elapsed(object sender, ElapsedEventArgs e)
    {
        await LoadData();
    }

    private async Task LoadData()
    {
        GridData = await departamentoAgent.Get();
        StateHasChanged();
    }

    private async void CreateItem(GridCommandEventArgs args)
    {
        try
        {
            DepartamentoDto depto = args.Item as DepartamentoDto;
            depto.Borrado = false;
            depto.CreadoPor = authenticationState.Result.User.Claims.Where(b => b.Type == "Id").FirstOrDefault().Value;
            depto.ModificadoPor = authenticationState.Result.User.Claims.Where(b => b.Type == "Id").FirstOrDefault().Value;
            await departamentoAgent.Add(depto);
            StateHasChanged();
        }
        catch (Exception ex)
        {
            Console.WriteLine(ex.Message);
            throw;
        }
    }

    private async void DeleteItem(GridCommandEventArgs args)
    {
        DepartamentoDto depto = args.Item as DepartamentoDto;
        try
        {
            if (await Dialog.ConfirmAsync("¿Está seguro que desea borrar este registro?"))
            {

            }
            await departamentoAgent.Remove(depto.Id);
        }
        catch (Exception ex)
        {
            Console.WriteLine(ex.Message);
            throw;
        }
        StateHasChanged();
    }

    private async void UpdateItem(GridCommandEventArgs args)
    {
        try
        {
            DepartamentoDto depto = args.Item as DepartamentoDto;
            depto.ModificadoPor = authenticationState.Result.User.Claims.Where(b => b.Type == "Id").FirstOrDefault().Value;
            await departamentoAgent.Edit(depto);
            StateHasChanged();
        }
        catch (Exception ex)
        {
            Console.WriteLine(ex.Message);
            throw;
        }

    }
}